/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

<Primer ejemplo: Ejemplo introductorio presentando los componentes basicos.>
Copyright (C) 2009, {Rosa Maria Durante, David Casas, Jose Galvan}
*/

#include <iostream>

#include "A02_F01.h"

IMPLEMENT_APP(MyApp)

//Tabla de eventos.
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
   EVT_BUTTON(wxID_OK, MyFrame::OnShow)
   EVT_BUTTON(wxID_EXIT, MyFrame::OnExit)
END_EVENT_TABLE()


//Manejador OnInit().
bool MyApp::OnInit()
{
   /* Creamos la ventana principal de la aplicacion. */
   MyFrame *frame = new MyFrame(wxT("Primer ejemplo"));
   
   /* Mostramos la ventana principal. */
   frame->Show(true);
   
   return true;
}


//Constructor.
MyFrame::MyFrame(const wxString& title)
       : wxFrame(NULL, wxID_ANY, title)
{
   btnShow = new wxButton(this, wxID_OK, 
			  wxString::FromUTF8("&Mostrar"), wxPoint(75,175), wxDefaultSize);
   btnExit = new wxButton(this, wxID_EXIT, 
			  wxString::FromUTF8("&Salir"), wxPoint(250,175), wxDefaultSize);
   label = new wxStaticText(this, wxID_ANY, 
			    wxString::FromUTF8("algo por defecto"), wxPoint(75,50), wxSize(200,75), 
			    wxALIGN_CENTER | wxST_NO_AUTORESIZE);
   label->SetFont(wxFont(26, wxFONTFAMILY_SWISS, wxITALIC, wxBOLD, false));
}

//Manejador OnShow()
void MyFrame::OnShow(wxCommandEvent& event)
{
  wxString wola = wxString::FromUTF8("Hola Mundo!");
  label->SetLabel(wola);
}

//Manejador OnExit()
void MyFrame::OnExit(wxCommandEvent& event)
{
   //Destruye Frame.
   Close();
}
