/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

<Ejemplo Capitulo 3: Ejemplo utilizando wxStaticText, wxTextCtrl, wxButton y wxMenu.>
Copyright (C) 2009, {Rosa Maria Durante, David Casas, Jose Galvan}
*/

#include "A03_F01.h"

IMPLEMENT_APP(MyApp)

enum idEjemplo {
   ID_SHOW = 0,
   ID_EXIT,
   ID_STATICTEXT,
   ID_TEXTCTRL
};

//Tabla de eventos.
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
   EVT_MENU(ID_SHOW, MyFrame::OnShow)
   EVT_MENU(ID_EXIT, MyFrame::OnExit)
   EVT_BUTTON(ID_SHOW, MyFrame::OnShow)
   EVT_BUTTON(ID_EXIT, MyFrame::OnExit)
END_EVENT_TABLE()


//Manejador OnInit().
bool MyApp::OnInit()
{
   /* Creamos la ventana principal de la aplicacion. */
   MyFrame *frame = new MyFrame(wxT("Ejemplo Capitulo 05"));
   
   /* Mostramos la ventana principal. */
   frame->Show(true);
   
   return true;
}


//Constructor.
MyFrame::MyFrame(const wxString& title)
       : wxFrame(NULL, wxID_ANY, title)
{
   mbMenu = new wxMenuBar;
   mnMenu = new wxMenu;
   mnMenu->Append(ID_SHOW, wxT("&Mostrar"));
   mnMenu->AppendSeparator();
   mnMenu->Append(ID_EXIT, wxT("&Salir"));
   mbMenu->Append(mnMenu,wxT("&Funcionalidades"));
   SetMenuBar(mbMenu);
   btnShow = new wxButton(this, ID_SHOW, wxT("&Mostrar"), wxPoint(100,150), wxDefaultSize);
   btnExit = new wxButton(this, ID_EXIT, wxT("&Salir"), wxPoint(200,150), wxDefaultSize);
   lblShow = new wxStaticText(this, ID_STATICTEXT, wxT(""), wxPoint(200,10), wxSize(150,100), wxALIGN_LEFT);
   tcText = new wxTextCtrl(this, ID_TEXTCTRL, wxEmptyString, wxPoint(10,10), wxSize(150,100), wxTE_NO_VSCROLL|wxTE_MULTILINE);
}


//Manejador OnShow()
void MyFrame::OnShow(wxCommandEvent& event)
{
  lblShow->SetLabel(tcText->GetValue());
}

//Manejador OnExit()
void MyFrame::OnExit(wxCommandEvent& event)
{
   //Destruye Frame.
   Close();
}
