/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

<Ejemplo Capitulo 5: Ejemplo utilizando wxChoice, wxComboBox, wxListBox, wxCheckBox y wxRadioBox.>
Copyright (C) 2009, {Rosa Maria Durante, David Casas, Jose Galvan}
*/

#include "A05_F01.h"

IMPLEMENT_APP(MyApp)

enum idEjemplo {
   ID_CHOICE = 0,
   ID_STATICTEXT,
   ID_COMBOBOX,
   ID_CHECKBOX_BL,
   ID_CHECKBOX_IT,
   ID_CHECKBOX_UN,
   ID_LISTBOX,
   ID_RADIOBOX,
   ID_TEXTCTRL,
   ID_EXIT
};

//Tabla de eventos.
BEGIN_EVENT_TABLE(MyFrame, wxFrame)
   EVT_CHOICE(ID_CHOICE, MyFrame::OnChoice)
   EVT_COMBOBOX(ID_COMBOBOX, MyFrame::OnComboBox)
   EVT_CHECKBOX(ID_CHECKBOX_BL, MyFrame::OnCheckBoxBold)
   EVT_CHECKBOX(ID_CHECKBOX_IT, MyFrame::OnCheckBoxItalic)
   EVT_CHECKBOX(ID_CHECKBOX_UN, MyFrame::OnCheckBoxUnderline)
   EVT_LISTBOX(ID_LISTBOX, MyFrame::OnListBox)
   EVT_RADIOBOX(ID_RADIOBOX, MyFrame::OnRadioBox)
   EVT_BUTTON(ID_EXIT, MyFrame::OnExit)
END_EVENT_TABLE()


//Manejador OnInit().
bool MyApp::OnInit()
{
   /* Creamos la ventana principal de la aplicacion. */
   MyFrame *frame = new MyFrame(wxT("Ejemplo Capitulo 05"));
   
   /* Mostramos la ventana principal. */
   frame->Show(true);
   
   return true;
}


//Constructor.
MyFrame::MyFrame(const wxString& title)
       : wxFrame(NULL, wxID_ANY, title, wxDefaultPosition, wxSize(450,300))
{
   wxArrayString chString, cbString, lbString, rbString;
   chString.Add(wxT("Predeterminado 1"));
   chString.Add(wxT("Predeterminado 2"));
   chString.Add(wxT("Predeterminado 3"));
   cbString.Add(wxT("Arial"));
   cbString.Add(wxT("Times New Roman"));
   cbString.Add(wxT("Sans Serif"));
   lbString.Add(wxT("8"));
   lbString.Add(wxT("12"));
   lbString.Add(wxT("16"));
   lbString.Add(wxT("20"));
   rbString.Add(wxT("Negro"));
   rbString.Add(wxT("Azul"));
   
   lblFont = new wxStaticText(this, ID_STATICTEXT, wxT("Fuente:"), wxPoint(310,85), wxDefaultSize);
   lblchoice = new wxStaticText(this, ID_STATICTEXT, wxT("Predefinidos:"), wxPoint(310,10), wxDefaultSize);
   lblStyle = new wxStaticText(this, ID_STATICTEXT, wxString::FromUTF8("Estilos:"), wxPoint(165,10), wxDefaultSize);
   lblSize = new wxStaticText(this, ID_STATICTEXT, wxString::FromUTF8("Tamao:"), wxPoint(30,10), wxDefaultSize);
   lblText = new wxStaticText(this, ID_STATICTEXT, wxT("Texto:"), wxPoint(10,100), wxDefaultSize);
   choice = new wxChoice(this, ID_CHOICE, wxPoint(310,25), wxDefaultSize, chString);
   cbFont = new wxComboBox(this, ID_COMBOBOX, wxT("Arial"), wxPoint(310,100), wxDefaultSize, cbString, wxCB_READONLY);
   lbSize = new wxListBox(this, ID_LISTBOX, wxPoint(45,25), wxSize(30,65), lbString, wxLB_SINGLE);
   ckStyleBl = new wxCheckBox(this, ID_CHECKBOX_BL, wxT("Negrita"), wxPoint(165,25), wxDefaultSize);
   ckStyleIt = new wxCheckBox(this, ID_CHECKBOX_IT, wxT("Cursiva"), wxPoint(165,45), wxDefaultSize);
   ckStyleUn = new wxCheckBox(this, ID_CHECKBOX_UN, wxT("Subrayado"), wxPoint(165,65), wxDefaultSize);
   rbColor = new wxRadioBox(this, ID_RADIOBOX, wxT("Colores"), wxPoint(310,165), wxDefaultSize, rbString, 2, 1);
   tcText = new wxTextCtrl(this, ID_TEXTCTRL, wxEmptyString, wxPoint(10,115), wxSize(275,150), wxTE_NO_VSCROLL|wxTE_MULTILINE);
   btnExit = new wxButton(this, ID_EXIT, wxT("&Salir"), wxPoint(325,235), wxDefaultSize);
}

//Manejador OnChoice()
void MyFrame::OnChoice(wxCommandEvent& event)
{
/*
  if(choice->GetSelection()==0)
    tcText->SetFont(wxFont(12,tcText->GetFont().GetFamily(),wxFONTSTYLE_ITALIC,tcText->GetFont().GetWeight(),tcText->GetFont.GetUnderlined(),wxT("")));
  else
    if(choice->GetSelection()==1)
      tcText->SetFont(wxFont(8,wxFONTFAMILY_SWISS,tcText->GetFont().GetStyle(),wxFONTWEIGHT_BOLD,tcText->GetFont.GetUnderlined(),wxT("")));
    else
      if(choice->GetSelection()==2)
        tcText->SetFont(wxFont(16,wxFONTFAMILY_ROMAN,tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),1,wxT("")));
*/
}

//Manejador OnListBox()
void MyFrame::OnListBox(wxCommandEvent& event)
{
  if(lbSize->IsSelected(0))
    tcText->SetFont(wxFont(8,tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),tcText->GetFont().GetUnderlined(),wxT("")));
  else
    if(lbSize->IsSelected(1))
      tcText->SetFont(wxFont(12,tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),tcText->GetFont().GetUnderlined(),wxT("")));
    else
      if(lbSize->IsSelected(2))
        tcText->SetFont(wxFont(16,tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),tcText->GetFont().GetUnderlined(),wxT("")));
      else
        if(lbSize->IsSelected(3))
          tcText->SetFont(wxFont(20,tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),tcText->GetFont().GetUnderlined(),wxT("")));
}

//Manejador OnCheckBoxBold()
void MyFrame::OnCheckBoxBold(wxCommandEvent& event)
{
  if(ckStyleBl->IsChecked())
    tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),wxFONTWEIGHT_BOLD,tcText->GetFont().GetUnderlined(),wxT("")));
  else
    tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),wxFONTWEIGHT_NORMAL,tcText->GetFont().GetUnderlined(),wxT("")));
}

//Manejador OnCheckBoxItalic()
void MyFrame::OnCheckBoxItalic(wxCommandEvent& event)
{
  if(ckStyleIt->IsChecked())
    tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),tcText->GetFont().GetFamily(),wxFONTSTYLE_ITALIC,tcText->GetFont().GetWeight(),tcText->GetFont().GetUnderlined(),wxT("")));
  else
    tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),tcText->GetFont().GetFamily(),wxFONTSTYLE_NORMAL,tcText->GetFont().GetWeight(),tcText->GetFont().GetUnderlined(),wxT("")));
}

//Manejador OnCheckBoxUnderline()
void MyFrame::OnCheckBoxUnderline(wxCommandEvent& event)
{
  if(ckStyleUn->IsChecked())
    tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),1,wxT("")));
  else
    tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),0,wxT("")));
}

//Manejador OnComboBox()
void MyFrame::OnComboBox(wxCommandEvent& event)
{
/*
  if(cbFont->GetSelection()==0);
    tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),tcText->GetFont().GetFamily(),tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),tcText->GetFont.GetUnderlined(),wxT("")));
  else
    if(cbFont->GetSelection()==1);
      tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),wxFONTFAMILY_ROMAN,tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),tcText->GetFont.GetUnderlined(),wxT("")));
    else
      if(cbFont->GetSelection()==2)
        tcText->SetFont(wxFont(tcText->GetFont().GetPointSize(),wxFONTFAMILY_SWISS,tcText->GetFont().GetStyle(),tcText->GetFont().GetWeight(),tcText->GetFont.GetUnderlined(),wxT("")));
*/
}

//Manejador OnRadioBox()
void MyFrame::OnRadioBox(wxCommandEvent& event)
{
  if(rbColor->GetSelection()==0)
    tcText->SetForegroundColour(wxColour(0,0,0));
  else
    if(rbColor->GetSelection()==1)
      tcText->SetForegroundColour(wxColour(0,0,255));
}

//Manejador OnExit()
void MyFrame::OnExit(wxCommandEvent& event)
{
   //Destruye Frame.
   Close();
}
