
/*
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program. If not, see <http://www.gnu.org/licenses/>.

< wxTutorial! Tutorial para el aprendizaje de las bibliotecas wxWidgets.>
Copyright (C) 2009, {Rosa Maria Durante, David Casas, Jose Galvan}
*/

#include "ddl.h"
#include "path.h"


DialogDownloadCode::DialogDownloadCode(wxWindow* parent, wxWindowID id, const wxString& title):
  wxDialog(parent, id, title, wxDefaultPosition, wxSize(350,160))
{
  Centre();
  
  ok = new wxButton(this, wxID_OK, wxString::FromUTF8("Aplicar"), wxPoint(250,100));
  cancel = new wxButton(this, wxID_CANCEL, wxString::FromUTF8("Cancelar"), wxPoint(130,100));
  
  labelcode = new wxStaticText(this, wxID_ANY, wxString::FromUTF8("Selecciona el código a descargar:"), wxPoint(30,20));
  
  wxString aux[4] = {wxString::FromUTF8("Hola Mundo."),
		     wxString::FromUTF8("Ejemplo Capítulo 03 y 04."),
		     wxString::FromUTF8("Ejemplo Capítulo 05."),
		     wxString::FromUTF8("wxTutorial.")};
  
  code = new wxComboBox(this, wxID_ANY, wxString::FromUTF8("Selecciona un ejemplo..."), wxPoint(20,50), wxSize(310, 30),4, aux, wxCB_DROPDOWN | wxCB_READONLY );
  
}

void DialogDownloadCode::Process()
{
  wxFileDialog savefile(this, wxString::FromUTF8("Exportar código:"),
					    wxString::FromUTF8(""), wxString::FromUTF8(""),
					    wxString::FromUTF8("*.zip"), wxFD_SAVE);
  
  if(code->GetCurrentSelection() == -1)
      wxMessageBox(wxString::FromUTF8("Al no haber seleccionado nada no descargará ningún código. Vuelva a abrir el diálogo de descargas de código para acceder al código de un ejemplo."));
  else {                   
    if(savefile.ShowModal() == wxID_OK){
      wxString getpath = savefile.GetPath();
      
#ifdef __WXGTK__
      getpath = getpath + wxString::FromUTF8(".zip");
#endif
      
      wxCopyFile(Path::GetPathExe(code->GetCurrentSelection()), getpath, true);
    }
  }
  Close();
}

DialogDownloadExe::DialogDownloadExe(wxWindow* parent, wxWindowID id, const wxString& title):
  wxDialog(parent, id, title, wxDefaultPosition, wxSize(350,160))
{
  Centre();
  
  ok = new wxButton(this, wxID_OK, wxString::FromUTF8("Aplicar"), wxPoint(250,100));
  cancel = new wxButton(this, wxID_CANCEL, wxString::FromUTF8("Cancelar"), wxPoint(130,100));
  
  labelexe = new wxStaticText(this, wxID_ANY, wxString::FromUTF8("Selecciona el ejecutable a descargar:"), wxPoint(30,20));
  
  wxString aux[4] = {wxString::FromUTF8("Hola Mundo."),
		     wxString::FromUTF8("Ejemplo Capítulo 03 y 04."),
		     wxString::FromUTF8("Ejemplo Capítulo 05."),
		     wxString::FromUTF8("wxTutorial.")};
  
  exe = new wxComboBox(this, wxID_ANY, wxString::FromUTF8("Selecciona un ejemplo..."), wxPoint(20,50), wxSize(310, 30),4, aux, wxCB_DROPDOWN | wxCB_READONLY );
  
}

void DialogDownloadExe::Process()
{
  wxFileDialog savefile(this, wxString::FromUTF8("Exportar ejecutables:"),
					    wxString::FromUTF8(""), wxString::FromUTF8(""),
					    wxString::FromUTF8("*.zip"), wxFD_SAVE);
  
  if(exe->GetCurrentSelection() == -1)
      wxMessageBox(wxString::FromUTF8("Al no haber seleccionado nada no descargará ningún fichero. Vuelva a abrir el diálogo de descargas para acceder al ejecutable de un ejemplo."));
  else {
    if(savefile.ShowModal() == wxID_OK){
      wxString getpath = savefile.GetPath();
      
#ifdef __WXGTK__
      getpath = getpath + wxString::FromUTF8(".zip");
#endif
      wxCopyFile(Path::GetPathExe(exe->GetCurrentSelection()+4), getpath, true);
    }
  }
  Close();
}

