
/*
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.

 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.

 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.

 * < wxTutorial! Tutorial para el aprendizaje de las bibliotecas wxWidgets.>
 * Copyright (C) 2009, {Rosa Maria Durante, David Casas, Jose Galvan}
*/

#ifndef _DIALOGDOWNLOAD_
#define _DIALOGDOWNLOAD_

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#include <wx/wx.h>
#include <wx/dialog.h>

/**
 * @brief Definición del diálogo para la descarga del código
 * fuente de los ejemplos.
 *
 * @author Rosa María Durante Lerate
 * @note Parte del proyecto wxTutorial!.
 */
class DialogDownloadCode : public wxDialog
{
 public:
  /**
   * @brief Constructor de la clase.
   * @param parent Puntero de tipo wxWindow siendo éste
   * el componente donde se ha llamado al diálogo.
   * @param id Identificador del diálogo.
   * @param title Título del diálogo.
   */
  DialogDownloadCode(wxWindow* parent, wxWindowID id, const wxString& title);
  /**
   * @brief Función por el cual, una vez se acepte
   * en el diálogo se procesa las opciones elegidas
   * por el usuario.
   */
  void Process();

 private:
  wxButton *ok;
  wxButton *cancel;

  wxStaticText *labelcode;
  wxComboBox *code;
  
};

/**
 * @brief Definición del diálogo para la descarga del
 * ejecutable de los ejemplos.
 *
 * @author Rosa María Durante Lerate
 * @note Parte del proyecto wxTutorial!
 */
class DialogDownloadExe : public wxDialog
{
 public:
  /**
   * @brief Constructor de la clase.
   * @param parent Puntero de tipo wxWindow siendo éste el
   * componente donde se ha llamado al diálogo. (ventana padre).
   * @param id Identificador de ventana.
   * @param title Nombre de la ventana de diálogo.
   */
  DialogDownloadExe(wxWindow* parent, wxWindowID id, const wxString& title);
  /**
   * @brief Función por el cual, una vez se acepte
   * en el diálogo se procesa las opciones elegidas
   * por el usuario.
   */
  void Process();
 private:
  wxButton *ok;
  wxButton *cancel;
  
  wxStaticText *labelexe;
  wxComboBox *exe;
};

#endif
